"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.minilinks = exports.Minilinks = exports.MinilinksGeneratorOptionsDefault = void 0;
exports.MinilinksGeneratorOptionsDefault = {
    id: 'id',
    type_id: 'type_id',
    type: 'type',
    typed: 'typed',
    from_id: 'from_id',
    from: 'from',
    out: 'out',
    to_id: 'to_id',
    to: 'to',
    in: 'in',
    inByType: 'inByType',
    outByType: 'outByType',
};
function Minilinks(options) {
    return function minilinks(linksArray = [], memory = {}) {
        const types = memory.types || {};
        const byId = memory.byId || {};
        const links = memory.links || [];
        const newLinks = [];
        for (let l = 0; l < linksArray.length; l++) {
            if (byId[linksArray[l][options.id]]) {
                if (options.handler)
                    options.handler(byId[linksArray[l][options.id]], memory);
            }
            else {
                const link = Object.assign(Object.assign({}, linksArray[l]), { [options.typed]: [], [options.in]: [], [options.out]: [], [options.inByType]: {}, [options.outByType]: {} });
                byId[link[options.id]] = link;
                types[link[options.type_id]] = types[link[options.type_id]] || [];
                types[link[options.type_id]].push(link);
                links.push(link);
                newLinks.push(link);
            }
        }
        for (let l = 0; l < newLinks.length; l++) {
            const link = newLinks[l];
            if (byId[link[options.type_id]]) {
                link[options.type] = byId[link[options.type_id]];
                byId[link[options.type_id]][options.typed].push(link);
            }
            if (byId[link[options.from_id]]) {
                link[options.from] = byId[link[options.from_id]];
                byId[link[options.from_id]][options.out].push(link);
                byId[link[options.from_id]][options.outByType][link[options.type_id]] = byId[link[options.from_id]][options.outByType][link[options.type_id]] || [];
                byId[link[options.from_id]][options.outByType][link[options.type_id]].push(link);
            }
            if (byId[link[options.to_id]]) {
                link[options.to] = byId[link[options.to_id]];
                byId[link[options.to_id]][options.in].push(link);
                byId[link[options.to_id]][options.inByType][link[options.type_id]] = byId[link[options.to_id]][options.inByType][link[options.type_id]] || [];
                byId[link[options.to_id]][options.inByType][link[options.type_id]].push(link);
            }
            if (options.handler)
                options.handler(link, memory);
        }
        if (!memory.types)
            memory.types = types;
        if (!memory.byId)
            memory.byId = byId;
        if (!memory.links)
            memory.links = links;
        return memory;
    };
}
exports.Minilinks = Minilinks;
exports.minilinks = Minilinks(exports.MinilinksGeneratorOptionsDefault);
//# sourceMappingURL=minilinks.js.map