"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.permissions = exports.generatePermissionWhere = void 0;
const global_ids_1 = require("./global-ids");
const generatePermissionWhere = (actionId, _or = []) => {
    return {
        _and: [
            {
                _or: [
                    { type_id: { _in: [global_ids_1.GLOBAL_ID_USER, global_ids_1.GLOBAL_ID_TYPE, global_ids_1.GLOBAL_ID_PACKAGE, global_ids_1.GLOBAL_ID_PACKAGE_ACTIVE, global_ids_1.GLOBAL_ID_PACKAGE_NAMESPACE, global_ids_1.GLOBAL_ID_PROMISE, global_ids_1.GLOBAL_ID_THEN, global_ids_1.GLOBAL_ID_REJECTED, global_ids_1.GLOBAL_ID_RESOLVED] } },
                    { type_id: { _eq: global_ids_1.GLOBAL_ID_CONTAIN }, from: { type_id: { _eq: global_ids_1.GLOBAL_ID_PACKAGE } } },
                    { in: { type_id: { _eq: global_ids_1.GLOBAL_ID_CONTAIN }, from: { type_id: { _eq: global_ids_1.GLOBAL_ID_PACKAGE } } } },
                    {
                        _by_item: {
                            _and: [
                                {
                                    path_item: {
                                        in: {
                                            from: {
                                                in: {
                                                    type_id: { _eq: global_ids_1.GLOBAL_ID_OBJECT },
                                                    from: {
                                                        _and: [
                                                            { type_id: { _eq: global_ids_1.GLOBAL_ID_RULE } },
                                                            {
                                                                out: {
                                                                    type_id: { _eq: global_ids_1.GLOBAL_ID_ACTION },
                                                                    to: { out: { to_id: { _eq: actionId } } },
                                                                },
                                                            },
                                                            {
                                                                out: {
                                                                    type_id: { _eq: global_ids_1.GLOBAL_ID_SUBJECT },
                                                                    to: { out: { to_id: { _eq: 'X-Hasura-User-Id' } } },
                                                                },
                                                            },
                                                        ],
                                                    },
                                                },
                                                type_id: { _eq: global_ids_1.GLOBAL_ID_SELECTOR },
                                            },
                                            type_id: { _eq: global_ids_1.GLOBAL_ID_SELECTION },
                                        },
                                    },
                                },
                            ],
                        },
                    },
                ],
            },
            { type_id: { _ne: 0 } },
            ..._or,
        ],
    };
};
exports.generatePermissionWhere = generatePermissionWhere;
const permissions = (api, table, actions = {
    select: {},
    insert: {},
    update: {},
    delete: {},
    columns: '*',
    computed_fields: [],
}) => __awaiter(void 0, void 0, void 0, function* () {
    const columns = actions.columns || '*';
    const computed_fields = actions.computed_fields || [];
    yield api.metadata({
        type: 'pg_create_select_permission',
        args: {
            table: table,
            role: 'guest',
            permission: {
                columns: columns,
                computed_fields,
                filter: {},
                limit: 999,
                allow_aggregations: true
            }
        }
    });
    yield api.query({
        type: 'create_insert_permission',
        args: {
            table: table,
            role: 'guest',
            permission: {
                check: {},
                columns: '*',
            }
        }
    });
    yield api.query({
        type: 'create_update_permission',
        args: {
            table: table,
            role: 'guest',
            permission: {
                columns: '*',
                filter: {},
                check: {},
            }
        }
    });
    yield api.query({
        type: 'create_delete_permission',
        args: {
            table: table,
            role: 'guest',
            permission: {
                filter: {},
            }
        }
    });
    yield api.metadata({
        type: 'pg_create_select_permission',
        args: {
            table: table,
            role: 'link',
            permission: {
                columns: columns,
                computed_fields,
                filter: actions.select,
                limit: 999,
                allow_aggregations: true
            }
        }
    });
    yield api.query({
        type: 'create_insert_permission',
        args: {
            table: table,
            role: 'link',
            permission: {
                check: actions.insert,
                columns: '*',
            }
        }
    });
    yield api.query({
        type: 'create_update_permission',
        args: {
            table: table,
            role: 'link',
            permission: {
                columns: '*',
                filter: actions.update,
                check: {},
            }
        }
    });
    yield api.query({
        type: 'create_delete_permission',
        args: {
            table: table,
            role: 'link',
            permission: {
                filter: actions.delete,
            }
        }
    });
});
exports.permissions = permissions;
//# sourceMappingURL=permission.js.map